"use strict";
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = _object_without_properties_loose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = function(target, all) {
    for(var name in all)__defProp(target, name, {
        get: all[name],
        enumerable: true
    });
};
var __copyProps = function(to, from, except, desc) {
    if (from && (typeof from === "undefined" ? "undefined" : _type_of(from)) === "object" || typeof from === "function") {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            var _loop = function() {
                var key = _step.value;
                if (!__hasOwnProp.call(to, key) && key !== except) __defProp(to, key, {
                    get: function() {
                        return from[key];
                    },
                    enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable
                });
            };
            for(var _iterator = __getOwnPropNames(from)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop();
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return to;
};
var __toESM = function(mod, isNodeMode, target) {
    return target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(// If the importer is in node compatibility mode or this is not an ESM
    // file that has been converted to a CommonJS file using a Babel-
    // compatible transform (i.e. "__esModule" has not been set), then set
    // "default" to the CommonJS "module.exports" for node compatibility.
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", {
        value: mod,
        enumerable: true
    }) : target, mod);
};
var __toCommonJS = function(mod) {
    return __copyProps(__defProp({}, "__esModule", {
        value: true
    }), mod);
};
// src/index.ts
var src_exports = {};
__export(src_exports, {
    default: function() {
        return initAjax;
    }
});
module.exports = __toCommonJS(src_exports);
var import_axios2 = __toESM(require("axios"));
// src/adapters/wx-adapter.ts
var import_axios = require("axios");
// src/utils.ts
var import_object_hash = __toESM(require("object-hash"));
function isAbsoluteURL(url) {
    return /^([a-z][a-z\d+-.]*:)?\/\//i.test(url);
}
function combineURLs(baseURL, relativeURL) {
    return relativeURL ? "".concat(baseURL.replace(/\/+$/, ""), "/").concat(relativeURL.replace(/^\/+/, "")) : baseURL;
}
function buildFullPath(baseURL, requestedURL) {
    if (baseURL && !isAbsoluteURL(requestedURL)) {
        return combineURLs(baseURL, requestedURL);
    }
    return requestedURL;
}
function deepCopy(obj) {
    var target;
    if ((typeof obj === "undefined" ? "undefined" : _type_of(obj)) === "object" && obj !== null) {
        if (Array.isArray(obj)) {
            target = [];
            obj.forEach(function(elem) {
                return target.push(deepCopy(elem));
            });
        } else {
            target = {};
            Object.keys(obj).forEach(function(key) {
                target[key] = deepCopy(obj[key]);
            });
        }
    } else {
        target = obj;
    }
    return target;
}
function generateRequestHash(config) {
    var _config_url = config.url, url = _config_url === void 0 ? "" : _config_url, _config_method = config.method, method = _config_method === void 0 ? "" : _config_method, _config_params = config.params, params = _config_params === void 0 ? {} : _config_params, _config_data = config.data, data = _config_data === void 0 ? {} : _config_data, _config_baseURL = config.baseURL, baseURL = _config_baseURL === void 0 ? "" : _config_baseURL;
    return (0, import_object_hash.default)(_object_spread_props(_object_spread({}, params, data), {
        baseURL: baseURL,
        url: url,
        method: method
    }));
}
// src/canceller.ts
var canceller = {};
function addRecord(record, cancelKey, hash2, cancelFn) {
    var cancelObj = record[cancelKey] || {};
    cancelObj[hash2] = cancelFn;
    record[cancelKey] = cancelObj;
}
function deleteRecordByHash(record, cancelKey, hash2) {
    var cancelObj = record[cancelKey] || {};
    if (!cancelObj[hash2]) return;
    Reflect.deleteProperty(cancelObj, hash2);
    if (Object.keys(cancelObj).length === 0) {
        Reflect.deleteProperty(record, cancelKey);
        return;
    }
    record[cancelKey] = cancelObj;
}
function addCanceller(cancelKey, hash2, cancelFn) {
    addRecord(canceller, cancelKey, hash2, cancelFn);
}
function deleteCancellerByHash(cancelKey, hash2) {
    deleteRecordByHash(canceller, cancelKey, hash2);
}
function hasCancelers(cancelKey) {
    var cancelObj = canceller[cancelKey];
    if (!cancelObj || Object.keys(cancelObj).length === 0) return false;
    return true;
}
function callCancellerByCancelKey(cancelKey) {
    if (!hasCancelers(cancelKey)) return;
    Object.entries(canceller[cancelKey]).forEach(function(param) {
        var _param = _sliced_to_array(param, 2), hash2 = _param[0], fn = _param[1];
        fn.call();
        deleteCancellerByHash(cancelKey, hash2);
    });
}
var cancellerCalled = {};
function addCalledCanceller(cancelKey, hash2, cancelFn) {
    addRecord(cancellerCalled, cancelKey, hash2, cancelFn);
}
function deleteCalledCancellerByHash(cancelKey, hash2) {
    deleteRecordByHash(cancellerCalled, cancelKey, hash2);
}
function hasCalledCancelerRecord(cancelKey, hash2) {
    return cancellerCalled[cancelKey] && cancellerCalled[cancelKey][hash2];
}
// src/cancelLastSameRequest.ts
var cancellerCache = {};
function addRequestCanceler(url, hash2, cancelFn) {
    var urlCache = cancellerCache[url] || {};
    urlCache[hash2] = cancelFn;
    cancellerCache[url] = urlCache;
}
function clearCancelerByHash(url, hash2) {
    if (cancellerCache[url] && cancellerCache[url][hash2]) {
        Reflect.deleteProperty(cancellerCache[url], hash2);
        if (Object.keys(cancellerCache[url]).length === 0) {
            Reflect.deleteProperty(cancellerCache, url);
        }
    }
}
function execCanceler(url) {
    var cancelers = cancellerCache[url] || {};
    Object.entries(cancelers).forEach(function(param) {
        var _param = _sliced_to_array(param, 2), key = _param[0], fn = _param[1];
        fn();
        Reflect.deleteProperty(cancelers, key);
    });
    Reflect.deleteProperty(cancellerCache, url);
}
// src/adapters/wx-adapter.ts
function wxAdapter(config) {
    return new Promise(function(resolve, reject) {
        var requestConfig = {};
        var isAborted = false;
        var requestTask = null;
        var headers = config.headers, data = config.data, params = config.params, url = config.url, timeout = config.timeout, method = config.method, rest = _object_without_properties(config, [
            "headers",
            "data",
            "params",
            "url",
            "timeout",
            "method"
        ]);
        var requestHash = generateRequestHash(config);
        var requestHeader = deepCopy(headers);
        delete requestHeader.Referer;
        requestConfig.header = requestHeader;
        var requestData = data || params;
        requestConfig.data = deepCopy(requestData);
        requestConfig.url = buildFullPath(config.baseURL || "", url || "");
        requestConfig.timeout = timeout;
        requestConfig.method = method === null || method === void 0 ? void 0 : method.toUpperCase();
        requestConfig = _object_spread({}, requestConfig, rest);
        requestConfig.success = function(res) {
            var response = {};
            var resData = res.data, statusCode = res.statusCode, header = res.header, restRes = _object_without_properties(res, [
                "data",
                "statusCode",
                "header"
            ]);
            response.data = resData;
            response.status = statusCode;
            response.headers = header;
            response.config = config;
            response = _object_spread({}, response, restRes);
            var validateStatus = response.config.validateStatus;
            if (!response.status || !validateStatus || validateStatus(response.status)) {
                resolve(response);
            } else {
                var errMsg = "Request failed with status code ".concat(response.status);
                reject(new import_axios.AxiosError(errMsg, "", config, requestTask, response));
            }
        };
        requestConfig.fail = function(err) {
            if (isAborted) {
                reject(new import_axios.AxiosError(err.errMsg, import_axios.AxiosError.ERR_CANCELED, config, requestTask));
            }
            reject(new import_axios.AxiosError(err.errMsg, err.errno, config, requestTask));
        };
        if (hasCalledCancelerRecord(requestConfig.cancelKey, requestHash)) {
            reject(new import_axios.AxiosError("\u8BF7\u6C42\u5728\u53D1\u51FA\u4E4B\u524D\u88AB\u4E3B\u52A8\u53D6\u6D88\uFF01", import_axios.AxiosError.ERR_CANCELED, config, requestTask));
            deleteCalledCancellerByHash(requestConfig.cancelKey, requestHash);
            return;
        }
        requestTask = wx.request(requestConfig);
        if ("undefined" === typeof AbortController) {
            if (requestConfig.cancelKey) {
                addCanceller(requestConfig.cancelKey, requestHash, function() {
                    isAborted = true;
                    requestTask.abort.call(requestTask);
                    deleteCancellerByHash(requestConfig.cancelKey, requestHash);
                    reject(new import_axios.AxiosError("\u8BF7\u6C42\u88AB\u53D6\u6D88\uFF01", import_axios.AxiosError.ERR_CANCELED, config, requestTask));
                });
            }
            if (requestConfig.cancelLastSameUrl && requestConfig.method.toLocaleLowerCase() === "get") {
                addRequestCanceler(config.url, requestHash, function() {
                    isAborted = true;
                    requestTask.abort.call(requestTask);
                    clearCancelerByHash(config.url, requestHash);
                    reject(new import_axios.AxiosError("\u8BF7\u6C42\u88AB\u53D6\u6D88\uFF01", import_axios.AxiosError.ERR_CANCELED, config, requestTask));
                });
            }
        }
    });
}
wxAdapter.type = "wx";
// src/duplicateRequestPrevent.ts
var pendingRequest = {};
function addPendingRequest(hash2, request, timeout) {
    pendingRequest[hash2] = request;
    setTimeout(function() {
        clearPendingRequest(hash2);
    }, timeout);
}
function clearPendingRequest(hash2) {
    Reflect.deleteProperty(pendingRequest, hash2);
}
function checkIfHasPendingRequest(hashKey) {
    return Reflect.has(pendingRequest, hashKey);
}
function getCachedRequest(hashKey) {
    return pendingRequest[hashKey];
}
// src/helpers.ts
var import_qs = __toESM(require("qs"));
function normalizeConfig(ctx, config) {
    var _ref = _object_spread({}, ctx.$options, config), _ref_headers = _ref.headers, headers = _ref_headers === void 0 ? {} : _ref_headers, _ref_sendFormData = _ref.sendFormData, sendFormData = _ref_sendFormData === void 0 ? false : _ref_sendFormData, _ref_data = _ref.data, data = _ref_data === void 0 ? void 0 : _ref_data, _ref_params = _ref.params, params = _ref_params === void 0 ? {} : _ref_params, _ref_baseUrl = _ref.baseUrl, baseUrl = _ref_baseUrl === void 0 ? "" : _ref_baseUrl, _ref_baseURL = _ref.baseURL, baseURL = _ref_baseURL === void 0 ? "" : _ref_baseURL, _ref_reUseDuration = _ref.reUseDuration, reUseDuration = _ref_reUseDuration === void 0 ? 300 : _ref_reUseDuration, rest = _object_without_properties(_ref, [
        "headers",
        "sendFormData",
        "data",
        "params",
        "baseUrl",
        "baseURL",
        "reUseDuration"
    ]);
    var contentType = headers["content-type"] || headers["Content-Type"] || "application/json";
    headers["content-type"] = sendFormData ? "application/x-www-form-urlencoded" : contentType;
    var sendData = sendFormData && (typeof data === "undefined" ? "undefined" : _type_of(data)) === "object" && data !== null ? import_qs.default.stringify(data) : data;
    var bUrl = baseUrl || baseURL || ctx.$baseUrl;
    if (typeof reUseDuration !== "number" || Number.isNaN(reUseDuration)) {
        throw new Error("ajax\u914D\u7F6EreUseDuration\u5FC5\u987B\u662F\u6570\u5B57");
    }
    return _object_spread({
        headers: headers,
        params: params,
        data: sendData,
        baseURL: bUrl,
        reUseDuration: reUseDuration
    }, rest);
}
function addInstanceExtendMethod(ctx) {
    var extend = function(source) {
        Object.keys(source).forEach(function(key) {
            ctx[key] = source[key];
        });
    };
    ctx.extend = extend;
}
function proxyAxiosInstanceAttrs(target, source) {
    var attrs = [
        "request",
        "interceptors",
        "defaults"
    ];
    attrs.forEach(function(method) {
        Object.defineProperty(target, method, {
            value: source[method],
            writable: false
        });
    });
}
function proxyAjaxCanceler(ctx) {
    ctx.canceller = new Proxy({}, {
        get: function get(target, prop) {
            if (!hasCancelers(prop)) {
                return function() {
                    var str = "ajax.canceller对象上不存在名为".concat(prop, "的函数！");
                    console.warn(str);
                    return str;
                };
            }
            return function() {
                callCancellerByCancelKey(prop);
            };
        }
    });
}
// src/compatibleMethods.ts
var methodMap = {
    query: "GET",
    create: "POST",
    putWay: "PUT",
    deletes: "DELETE",
    patchWay: "PATCH"
};
var generateCustomMethod = function(ctx, name) {
    return function(path) {
        var config = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        return function() {
            var _ref = _async_to_generator(function(data, expand) {
                var url, _ref, newParams, newData, config1, options, hashKey, request, res;
                return _ts_generator(this, function(_state) {
                    switch(_state.label){
                        case 0:
                            url = expand ? "".concat(path, "/").concat(expand) : path;
                            if (expand) {
                                console.warn("业务代码中拼接url发送请求的方式即将废弃，请使用ajax.".concat(methodMap[name].toLocaleLowerCase(), "接口替换。相关url：").concat(url));
                            }
                            _ref = _sliced_to_array(methodMap[name] === "GET" ? [
                                data,
                                void 0
                            ] : [
                                void 0,
                                data
                            ], 2), newParams = _ref[0], newData = _ref[1];
                            config1 = normalizeConfig(ctx, _object_spread_props(_object_spread({}, config), {
                                url: url,
                                params: newParams,
                                data: newData,
                                method: methodMap[name]
                            }));
                            options = _object_spread_props(_object_spread({}, config1), {
                                custom: _object_spread({}, ctx.$options, config1)
                            });
                            hashKey = generateRequestHash(config1);
                            if (checkIfHasPendingRequest(hashKey)) {
                                return [
                                    2,
                                    getCachedRequest(hashKey)
                                ];
                            }
                            request = ctx.request(options);
                            addPendingRequest(hashKey, request, options.reUseDuration);
                            return [
                                4,
                                request
                            ];
                        case 1:
                            res = _state.sent();
                            clearPendingRequest(hashKey);
                            return [
                                2,
                                res
                            ];
                    }
                });
            });
            return function(data, expand) {
                return _ref.apply(this, arguments);
            };
        }();
    };
};
function addCompatibleMethods(ctx) {
    ctx.query = generateCustomMethod(ctx, "query");
    ctx.create = generateCustomMethod(ctx, "create");
    ctx.deletes = generateCustomMethod(ctx, "deletes");
    ctx.putWay = generateCustomMethod(ctx, "putWay");
    ctx.patchWay = generateCustomMethod(ctx, "patchWay");
}
var compatibleMethods_default = addCompatibleMethods;
// src/methods.ts
var postLikeMethods = [
    "PUT",
    "POST",
    "DELETE",
    "PATCH"
];
var generateMethod = function(ajax, method) {
    return(/**
   *
   * @param url 完整的请求url链接
   * @param options ajax配置
   * @returns 返回一个发送请求的函数
   */ function(url, options) {
        return function() {
            var _ref = /**
     * 发送请求
     * @param params get类请求的url参数 or post类请求的请求体数据
     * @param opts ajax参数，拥有最高优先级
     * @returns 请求数据
     */ _async_to_generator(function(params, opts) {
                var mergedOptions, isPostLikeMethod, config, finalOpts, mock, hashKey, currUrl, controller, request, e;
                return _ts_generator(this, function(_state) {
                    switch(_state.label){
                        case 0:
                            mergedOptions = _object_spread({}, options, opts);
                            isPostLikeMethod = postLikeMethods.includes(method);
                            config = _object_spread_props(_object_spread({}, mergedOptions), {
                                params: isPostLikeMethod ? void 0 : params,
                                data: isPostLikeMethod ? params : void 0,
                                url: url,
                                method: method
                            });
                            finalOpts = normalizeConfig(ajax, config);
                            mock = finalOpts.mock;
                            if (mock) {
                                return [
                                    2,
                                    Promise.resolve(mock)
                                ];
                            }
                            hashKey = generateRequestHash(finalOpts);
                            if (checkIfHasPendingRequest(hashKey)) {
                                return [
                                    2,
                                    getCachedRequest(hashKey)
                                ];
                            }
                            if (finalOpts.cancelLastSameUrl) {
                                currUrl = finalOpts.url;
                                execCanceler(currUrl);
                            }
                            if (typeof AbortController !== "undefined") {
                                controller = new AbortController();
                                finalOpts.signal = controller.signal;
                                if (typeof mergedOptions.cancelKey !== "undefined") {
                                    addCanceller(mergedOptions.cancelKey, hashKey, function() {
                                        controller.abort.call(controller);
                                        deleteCancellerByHash(mergedOptions.cancelKey, hashKey);
                                    });
                                }
                                if (finalOpts.cancelLastSameUrl && finalOpts.method.toLocaleLowerCase() === "get") {
                                    addRequestCanceler(finalOpts.url, hashKey, function() {
                                        controller.abort.call(controller);
                                        clearCancelerByHash(finalOpts.url, hashKey);
                                    });
                                }
                            } else {
                                finalOpts.signal = void 0;
                                if (typeof mergedOptions.cancelKey !== "undefined") {
                                    addCanceller(mergedOptions.cancelKey, hashKey, function() {
                                        addCalledCanceller(mergedOptions.cancelKey, hashKey, true);
                                        deleteCancellerByHash(mergedOptions.cancelKey, hashKey);
                                    });
                                }
                            }
                            _state.label = 1;
                        case 1:
                            _state.trys.push([
                                1,
                                3,
                                4,
                                5
                            ]);
                            request = ajax.request(finalOpts);
                            addPendingRequest(hashKey, request, finalOpts.reUseDuration);
                            return [
                                4,
                                request
                            ];
                        case 2:
                            return [
                                2,
                                _state.sent()
                            ];
                        case 3:
                            e = _state.sent();
                            return [
                                2,
                                Promise.reject(e)
                            ];
                        case 4:
                            deleteCancellerByHash(finalOpts.cancelKey, hashKey);
                            clearCancelerByHash(finalOpts.url, hashKey);
                            clearPendingRequest(hashKey);
                            return [
                                7
                            ];
                        case 5:
                            return [
                                2
                            ];
                    }
                });
            });
            return function(params, opts) {
                return _ref.apply(this, arguments);
            };
        }();
    });
};
// src/index.ts
function isWxapp() {
    return typeof wx !== "undefined" && typeof wx.request === "function";
}
function initAjax(options) {
    var ajax = {};
    ajax.$options = options;
    var adapter = ajax.$options.adapter || (isWxapp() ? wxAdapter : void 0);
    ajax.$options.adapter = adapter;
    ajax.$engine = import_axios2.default.create();
    var requestMethods = [
        "POST",
        "PUT",
        "PATCH",
        "DELETE",
        "GET",
        "HEAD"
    ];
    requestMethods.forEach(function(name) {
        var queryMethods = name.toLocaleLowerCase();
        ajax[queryMethods] = generateMethod(ajax, name);
    });
    proxyAjaxCanceler(ajax);
    proxyAxiosInstanceAttrs(ajax, ajax.$engine);
    compatibleMethods_default(ajax);
    addInstanceExtendMethod(ajax);
    return ajax;
}
//# sourceMappingURL=index.js.map