/**
 * 取消相同URL和method的上一个未结束请求，主要目的是防止页面切换时串数据，比如tab切换
 * 且只针对get请求
 */ // import hash from 'object-hash'
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
export { generateRequestHash } from "./utils";
var cancellerCache = {};
export function addRequestCanceler(url, hash, cancelFn) {
    var urlCache = cancellerCache[url] || {};
    urlCache[hash] = cancelFn;
    cancellerCache[url] = urlCache;
}
export function clearCancelerByHash(url, hash) {
    if (cancellerCache[url] && cancellerCache[url][hash]) {
        Reflect.deleteProperty(cancellerCache[url], hash);
        if (Object.keys(cancellerCache[url]).length === 0) {
            Reflect.deleteProperty(cancellerCache, url);
        }
    }
}
// export function checkIfHasURLCanceler(url: string): boolean {
//   if (!cancellerCache[url]) return false
//   if (Object.keys(cancellerCache[url]).length === 0) return false
//   return true
// }
export function execCanceler(url) {
    var cancelers = cancellerCache[url] || {};
    Object.entries(cancelers).forEach(function(param) {
        var _param = _sliced_to_array(param, 2), key = _param[0], fn = _param[1];
        fn();
        Reflect.deleteProperty(cancelers, key);
    });
    Reflect.deleteProperty(cancellerCache, url);
} // export function getCachedCanceler(hashKey: string) {
 //   return cancellerCache[hashKey]
 // }
