function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
export { generateRequestHash } from "./utils";
// 用来存储取消函数
export var canceller = {};
function addRecord(record, cancelKey, hash, cancelFn) {
    var cancelObj = record[cancelKey] || {};
    cancelObj[hash] = cancelFn;
    record[cancelKey] = cancelObj;
}
function deleteRecordByHash(record, cancelKey, hash) {
    var cancelObj = record[cancelKey] || {};
    if (!cancelObj[hash]) return;
    Reflect.deleteProperty(cancelObj, hash);
    if (Object.keys(cancelObj).length === 0) {
        Reflect.deleteProperty(record, cancelKey);
        return;
    }
    record[cancelKey] = cancelObj;
}
export function addCanceller(cancelKey, hash, cancelFn) {
    addRecord(canceller, cancelKey, hash, cancelFn);
}
export function deleteCancellerByHash(cancelKey, hash) {
    deleteRecordByHash(canceller, cancelKey, hash);
}
export function hasCancelers(cancelKey) {
    var cancelObj = canceller[cancelKey];
    if (!cancelObj || Object.keys(cancelObj).length === 0) return false;
    return true;
}
export function callCancellerByCancelKey(cancelKey) {
    if (!hasCancelers(cancelKey)) return;
    Object.entries(canceller[cancelKey]).forEach(function(param) {
        var _param = _sliced_to_array(param, 2), hash = _param[0], fn = _param[1];
        fn.call();
        deleteCancellerByHash(cancelKey, hash);
    });
}
// 用来存储已经被调用的取消函数名称
export var cancellerCalled = {};
export function addCalledCanceller(cancelKey, hash, cancelFn) {
    addRecord(cancellerCalled, cancelKey, hash, cancelFn);
}
export function deleteCalledCancellerByHash(cancelKey, hash) {
    deleteRecordByHash(cancellerCalled, cancelKey, hash);
}
export function hasCalledCancelerRecord(cancelKey, hash) {
    return cancellerCalled[cancelKey] && cancellerCalled[cancelKey][hash];
}
