export { generateRequestHash } from "./utils";
var pendingRequest = {};
export function addPendingRequest(hash, request, timeout) {
    pendingRequest[hash] = request;
    setTimeout(function() {
        clearPendingRequest(hash);
    }, timeout);
}
export function clearPendingRequest(hash) {
    Reflect.deleteProperty(pendingRequest, hash);
}
export function checkIfHasPendingRequest(hashKey) {
    return Reflect.has(pendingRequest, hashKey);
}
export function getCachedRequest(hashKey) {
    return pendingRequest[hashKey];
}
