function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
import { normalizeConfig } from './helpers';
import { addCalledCanceller, addCanceller, deleteCancellerByHash } from './canceller';
import { generateRequestHash } from './utils';
import { addPendingRequest, checkIfHasPendingRequest, clearPendingRequest, getCachedRequest } from './duplicateRequestPrevent';
import { addRequestCanceler, clearCancelerByHash, execCanceler } from './cancelLastSameRequest';
var postLikeMethods = [
    'PUT',
    'POST',
    'DELETE',
    'PATCH'
];
export var generateMethod = function(ajax, method) {
    return(/**
   *
   * @param url 完整的请求url链接
   * @param options ajax配置
   * @returns 返回一个发送请求的函数
   */ function(url, options) {
        return function() {
            var _ref = /**
     * 发送请求
     * @param params get类请求的url参数 or post类请求的请求体数据
     * @param opts ajax参数，拥有最高优先级
     * @returns 请求数据
     */ _async_to_generator(function(params, opts) {
                var mergedOptions, isPostLikeMethod, config, finalOpts, mock, hashKey, currUrl, controller, request, e;
                return _ts_generator(this, function(_state) {
                    switch(_state.label){
                        case 0:
                            mergedOptions = _object_spread({}, options, opts);
                            isPostLikeMethod = postLikeMethods.includes(method);
                            config = _object_spread_props(_object_spread({}, mergedOptions), {
                                params: isPostLikeMethod ? undefined : params,
                                data: isPostLikeMethod ? params : undefined,
                                url: url,
                                method: method
                            });
                            finalOpts = normalizeConfig(ajax, config);
                            // mock
                            mock = finalOpts.mock;
                            if (mock) {
                                return [
                                    2,
                                    Promise.resolve(mock)
                                ];
                            }
                            // 完全相同的请求，且都处于pending状态，复用上一个
                            hashKey = generateRequestHash(finalOpts);
                            if (checkIfHasPendingRequest(hashKey)) {
                                // 重复，且处于pending状态的请求，复用
                                return [
                                    2,
                                    getCachedRequest(hashKey)
                                ];
                            }
                            // 这个检查应该位于前面复用请求的逻辑后面，不能乱序
                            // 如果需要取消之前处于pending状态相同url请求
                            if (finalOpts.cancelLastSameUrl) {
                                currUrl = finalOpts.url;
                                // 执行所有缓存的url相关的取消函数
                                execCanceler(currUrl);
                            }
                            // 缓存当前请求的取消函数
                            if (typeof AbortController !== 'undefined') {
                                // 环境支持AbortController
                                controller = new AbortController();
                                finalOpts.signal = controller.signal;
                                if (typeof mergedOptions.cancelKey !== 'undefined') {
                                    addCanceller(mergedOptions.cancelKey, hashKey, function() {
                                        controller.abort.call(controller);
                                        // 删除挂载在ajax上的请求中断函数
                                        deleteCancellerByHash(mergedOptions.cancelKey, hashKey);
                                    });
                                }
                                // 缓存当前请求的取消函数，假如后续有相同的url请求需要取消该请求，可以通过这里缓存的函数实现（只针对get请求）
                                if (finalOpts.cancelLastSameUrl && finalOpts.method.toLocaleLowerCase() === 'get') {
                                    addRequestCanceler(finalOpts.url, hashKey, function() {
                                        controller.abort.call(controller);
                                        clearCancelerByHash(finalOpts.url, hashKey);
                                    });
                                }
                            } else {
                                // 环境如果不支持AbortController，取消函数挂载到ajax只能交给adapter里面去实现了
                                finalOpts.signal = undefined;
                                // 因为异步的关系(axios中发出请求之前，对拦截函数处理可能是异步的)，逻辑可能还没走到adapter中去，取消函数就已经被调用了
                                // 此时取消函数还是undefined，所以这里提供默认取消函数
                                if (typeof mergedOptions.cancelKey !== 'undefined') {
                                    addCanceller(mergedOptions.cancelKey, hashKey, function() {
                                        // 默认函数将已经调用的取消函数名称记录下来，在adapter中走到发送请求的逻辑时，直接中断即可
                                        addCalledCanceller(mergedOptions.cancelKey, hashKey, true);
                                        deleteCancellerByHash(mergedOptions.cancelKey, hashKey);
                                    });
                                }
                            }
                            _state.label = 1;
                        case 1:
                            _state.trys.push([
                                1,
                                3,
                                4,
                                5
                            ]);
                            request = ajax.request(finalOpts);
                            addPendingRequest(hashKey, request, finalOpts.reUseDuration);
                            return [
                                4,
                                request
                            ];
                        case 2:
                            return [
                                2,
                                _state.sent()
                            ];
                        case 3:
                            e = _state.sent();
                            return [
                                2,
                                Promise.reject(e)
                            ];
                        case 4:
                            // 请求成功，删除ajax.canceller上对应的取消函数
                            deleteCancellerByHash(finalOpts.cancelKey, hashKey);
                            // 删除用于取消相同URL请求功能而缓存的取消函数
                            clearCancelerByHash(finalOpts.url, hashKey);
                            // 删除缓存的请求（用于复用finalOpts.reUseDuration内完全相同的多个请求）
                            clearPendingRequest(hashKey);
                            return [
                                7
                            ];
                        case 5:
                            return [
                                2
                            ];
                    }
                });
            });
            return function(params, opts) {
                return _ref.apply(this, arguments);
            };
        }();
    });
};
